#include "StdAfx.h"
#include "Registry.h"


cQueueReg::cQueueReg()
{
	m_sPlayWave = gcnew String("");
    m_sPressDigitPlayWave = gcnew String("");

    m_objQueueOPList = gcnew ArrayList();
    m_objPressDigitList = gcnew ArrayList();
    m_objPressDigitUserList = gcnew ArrayList();
}

cLoginReg::cLoginReg()
{
	m_sPassword = gcnew String("");
    m_sCodec = gcnew String("");
    m_bBlock = false;
    m_bStealth = false;
}

cLineReg::cLineReg()
{
	m_sPassword = gcnew String("");
    m_sDisplayName = gcnew String("");
    m_sUserName = gcnew String("");
    m_sAuthUser = gcnew String("");
    m_sPassword = gcnew String("");
    m_sRealm = gcnew String("");
    m_sProxy = gcnew String("");
    m_sOutboundProxy = gcnew String("");
    m_sInCallType = gcnew String("");
    m_sInCallTo = gcnew String("");
    m_sCodec = gcnew String("");

	m_bRegister = false;
}

cDialPlanReg::cDialPlanReg()
{
	m_sLineName = gcnew String("");
    m_sCallPrefix = gcnew String("");
}

cRegistry::cRegistry(void)
{
	m_hKey = Registry::LocalMachine->CreateSubKey("SOFTWARE\\VaxTeleSrvSIP");
}

cRegistry::~cRegistry(void)
{
	if(m_hKey != nullptr)
		m_hKey->Close();
}

String^ cRegistry::GetStealthListenerMusic()
{
    if (m_hKey == nullptr)
        return gcnew String("");

    return (String^)m_hKey->GetValue("StealthListenMusic", "");
}

bool cRegistry::SetStealthListenerMusic(String^ sPlayWave)
{
    if (m_hKey == nullptr)
        return false;

    m_hKey->SetValue("StealthListenMusic", sPlayWave);

    return true;
}

String^ cRegistry::GetHoldMusic()
{
    if (m_hKey == nullptr)
        return gcnew String("");

    return (String^)m_hKey->GetValue("HoldMusic", "");
}

bool cRegistry::SetHoldMusic(String^ sPlayWave)
{
    if (m_hKey == nullptr)
        return false;

    m_hKey->SetValue("HoldMusic", sPlayWave);

    return true;
}

String^ cRegistry::GetDialToneMusic()
{
	if (m_hKey == nullptr)
        return gcnew String("");

    return (String^) m_hKey->GetValue("DialToneMusic", "");
}

bool cRegistry::SetDialToneMusic(String^ sPlayWave)
{
    if (m_hKey == nullptr)
        return false;

    m_hKey->SetValue("DialToneMusic", sPlayWave);

    return true;
}

bool cRegistry::GetStartServer()
{
    if(m_hKey == nullptr) return false;
        
	return Convert::ToBoolean(m_hKey->GetValue("ServerStart", true));
}

bool cRegistry::SetStartServer(bool bEnable)
{
    if(m_hKey == nullptr) return false;
    
    m_hKey->SetValue("ServerStart", bEnable, RegistryValueKind::DWord);

    return true;
}

bool cRegistry::SetComm(String^ sListenIP, String^ sListenPort, String^ sDominRealm)
{
    if (m_hKey == nullptr)
        return false;

    m_hKey->SetValue("ListenIP", sListenIP);
    m_hKey->SetValue("ListenPort", sListenPort);
    m_hKey->SetValue("DomainRealm", sDominRealm);

    return true;
}

bool cRegistry::GetComm(String^% sListenIP,  String^% sListenPort,  String^% sDominRealm)
{
    if (m_hKey == nullptr)
        return false;

    sListenIP = (String^) m_hKey->GetValue("ListenIP", "");
    sListenPort = (String^) m_hKey->GetValue("ListenPort", "5060");
    sDominRealm = (String^) m_hKey->GetValue("DomainRealm", "");

    return true;
}

///////////////////////////////////////////////////////

bool cRegistry::RemoveQueue(String^ sQueue)
{
    if (m_hKey == nullptr)
        return false;

    m_hKey->DeleteSubKey("Queue\\" + sQueue);

    return true;
}

bool cRegistry::EnumQueue(ArrayList^ objQueueList)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->OpenSubKey("Queue", false);
    if (hKey == nullptr) return false;

    array<String^>^ arrayQueue = hKey->GetSubKeyNames();

    for (int nCount = 0; nCount < arrayQueue->Length; nCount++)
        objQueueList->Add(arrayQueue[nCount]);
    
    hKey->Close();
    return true;
}

bool cRegistry::GetQueue(String^ sQueue,  cQueueReg^ objQueueReg)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->OpenSubKey("Queue\\" + sQueue, false);
    if (hKey == nullptr) return false;

    objQueueReg->m_objQueueOPList = gcnew ArrayList();

    for (int nCount = 0; ; nCount++)
    {
        String^ sValue = (String^)hKey->GetValue("op-" + nCount.ToString());
        if (sValue == nullptr) break;

        objQueueReg->m_objQueueOPList->Add(sValue);
    }
            
    objQueueReg->m_objPressDigitList = gcnew ArrayList();

    for (int nCount = 0; ; nCount++)
    {
        String^ sValue = (String^)hKey->GetValue("digit-" + nCount.ToString());
        if (sValue == nullptr) break;

        objQueueReg->m_objPressDigitList->Add(sValue);
    }

    objQueueReg->m_objPressDigitUserList = gcnew ArrayList();

    for (int nCount = 0;;nCount++)
    {
        String^ sValue = (String^)hKey->GetValue("digituser-" + nCount.ToString());
        if (sValue == nullptr) break;

        objQueueReg->m_objPressDigitUserList->Add(sValue);
    }
            
    objQueueReg->m_sPressDigitPlayWave = (String^)hKey->GetValue("digitplaywave", "");
    objQueueReg->m_sPlayWave = (String^)hKey->GetValue("playwave", "");

    hKey->Close();

    return true;
}

bool cRegistry::SetQueue(String^ sQueue,  cQueueReg^ objQueueReg)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->CreateSubKey("Queue\\" + sQueue);
    if (hKey == nullptr) return false;

    for (int nCount = 0; nCount < objQueueReg->m_objQueueOPList->Count; nCount++)
        hKey->SetValue("op-" + nCount.ToString(), objQueueReg->m_objQueueOPList[nCount]);

    for (int nCount = 0; nCount < objQueueReg->m_objPressDigitList->Count; nCount++)
        hKey->SetValue("digit-" + nCount.ToString(), objQueueReg->m_objPressDigitList[nCount]);

    for (int nCount = 0; nCount < objQueueReg->m_objPressDigitUserList->Count; nCount++)
        hKey->SetValue("digituser-" + nCount.ToString(), objQueueReg->m_objPressDigitUserList[nCount]);

    hKey->SetValue("playwave", objQueueReg->m_sPlayWave);
    hKey->SetValue("digitplaywave", objQueueReg->m_sPressDigitPlayWave);

    hKey->Close();

    return true;
}

bool cRegistry::IsQueueExist(String^ sQueue)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->OpenSubKey("Queue\\" + sQueue, false);
    if (hKey == nullptr) return false;

    hKey->Close();
    return true;
}

bool cRegistry::RemoveLogin(String^ sLogin)
{
    if (m_hKey == nullptr) return false;

    m_hKey->DeleteSubKey("Login\\" + sLogin);
    return true;
}

bool cRegistry::EnumLogin(ArrayList^ objLoginList)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->OpenSubKey("Login", false);
    if (hKey == nullptr) return false;

    array<String^>^ arrayLogin = hKey->GetSubKeyNames();

    for (int nCount = 0; nCount < arrayLogin->Length; nCount++)
        objLoginList->Add(arrayLogin[nCount]);

    hKey->Close();
    return true;
}

bool cRegistry::SetLogin(String^ sLogin, cLoginReg^ objLoginReg)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->CreateSubKey("Login\\" + sLogin);
    if (hKey == nullptr) return false;

    hKey->SetValue("password", objLoginReg->m_sPassword);
    hKey->SetValue("codec", objLoginReg->m_sCodec);
    hKey->SetValue("block", objLoginReg->m_bBlock, RegistryValueKind::DWord);
    hKey->SetValue("stealth", objLoginReg->m_bStealth, RegistryValueKind::DWord);

    hKey->Close();
    return true;
}

bool cRegistry::GetLogin(String^ sLogin, cLoginReg^ objLoginReg)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->OpenSubKey("Login\\" + sLogin, false);
    if (hKey == nullptr) return false;

    objLoginReg->m_sPassword = (String^)hKey->GetValue("password", "");
    objLoginReg->m_bBlock = Convert::ToBoolean(hKey->GetValue("block", true));
    objLoginReg->m_bStealth = Convert::ToBoolean(hKey->GetValue("stealth", false));
    objLoginReg->m_sCodec = (String^)hKey->GetValue("codec", "32014");

    hKey->Close();
    return true;
}

bool cRegistry::IsLoginExist(String^ sLogin)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->OpenSubKey("Login\\" + sLogin, false);
    if (hKey == nullptr) return false;

    hKey->Close();
    return true;
}

/*============================================*/

bool cRegistry::EnumLine(ArrayList^ objLineList)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->OpenSubKey("Line", false);
    if (hKey == nullptr) return false;

    array<String^>^ arrayLine = hKey->GetSubKeyNames();

    for (int nCount = 0; nCount < arrayLine->Length; nCount++)
        objLineList->Add(arrayLine[nCount]);

    hKey->Close();
    return true;
}

bool cRegistry::SetLine(String^ sLineName, cLineReg^ objLineReg)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->CreateSubKey("Line\\" + sLineName);
    if (hKey == nullptr) return false;

    hKey->SetValue("displayname", objLineReg->m_sDisplayName);
    hKey->SetValue("username", objLineReg->m_sUserName);
    hKey->SetValue("authuser", objLineReg->m_sAuthUser);
    hKey->SetValue("password", objLineReg->m_sPassword);
    hKey->SetValue("realm", objLineReg->m_sRealm);
    hKey->SetValue("proxy", objLineReg->m_sProxy);
    hKey->SetValue("outboundproxy", objLineReg->m_sOutboundProxy);
    hKey->SetValue("codec", objLineReg->m_sCodec);
    hKey->SetValue("regonstartup", objLineReg->m_bRegister, RegistryValueKind::DWord);
    hKey->SetValue("incalltype", objLineReg->m_sInCallType);
    hKey->SetValue("incallto", objLineReg->m_sInCallTo);

    hKey->Close();
    return true;
}

bool cRegistry::GetLine(String^ sLineName, cLineReg^ objLineReg)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->OpenSubKey("Line\\" + sLineName, false);
    if (hKey == nullptr) return false;

    objLineReg->m_sDisplayName = (String^)hKey->GetValue("displayname", "");
    objLineReg->m_sUserName = (String^)hKey->GetValue("username", "");
    objLineReg->m_sAuthUser = (String^)hKey->GetValue("authuser", "");
    objLineReg->m_sPassword = (String^)hKey->GetValue("password", "");
    objLineReg->m_sRealm = (String^)hKey->GetValue("realm", "");
    objLineReg->m_sProxy = (String^)hKey->GetValue("proxy", "");
    objLineReg->m_sOutboundProxy = (String^)hKey->GetValue("outboundproxy", "");

    objLineReg->m_sCodec = (String^)hKey->GetValue("codec", "32014");

    objLineReg->m_bRegister = Convert::ToBoolean(hKey->GetValue("regonstartup", false));

    objLineReg->m_sInCallType = (String^)hKey->GetValue("incalltype", "");
    objLineReg->m_sInCallTo = (String^)hKey->GetValue("incallto", "");

    hKey->Close();
    return true;
}

bool cRegistry::IsLineExist(String^ sLineName)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->OpenSubKey("Line\\" + sLineName, false);
    if (hKey == nullptr) return false;

    hKey->Close();
    return true;
}

bool cRegistry::RemoveLine(String^ sLineName)
{
    if (m_hKey == nullptr) return false;

    m_hKey->DeleteSubKey("Line\\" + sLineName);

    return true;
}

/*============================================*/

bool cRegistry::EnumDialPlan(ArrayList^ objUserPix)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->OpenSubKey("DialPlan", false);
    if (hKey == nullptr) return false;

    array<String^>^ arrayUserPix = hKey->GetSubKeyNames();

    for (int nCount = 0; nCount < arrayUserPix->Length; nCount++)
        objUserPix->Add(arrayUserPix[nCount]);

    hKey->Close();
    return true;
}

bool cRegistry::RemoveDialPlan(String^ sUserPix)
{
    if (m_hKey == nullptr) return false;

    m_hKey->DeleteSubKey("DialPlan\\" + sUserPix);

    return true;
}

bool cRegistry::SetDialPlan(String^ sUserPix, cDialPlanReg^ objDialPlanReg)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->CreateSubKey("DialPlan\\" + sUserPix);
    if (hKey == nullptr) return false;

    hKey->SetValue("LineName", objDialPlanReg->m_sLineName);
    hKey->SetValue("CallPix", objDialPlanReg->m_sCallPrefix);

    hKey->Close();
    return true;
}

bool cRegistry::GetDialPlan(String^ sUserPix, cDialPlanReg^ objDialPlanReg)
{
    if (m_hKey == nullptr) return false;

    RegistryKey^ hKey = m_hKey->OpenSubKey("DialPlan\\" + sUserPix, false);
    if (hKey == nullptr) return false;

    objDialPlanReg->m_sLineName = (String^)hKey->GetValue("LineName", "");
    objDialPlanReg->m_sCallPrefix = (String^)hKey->GetValue("CallPix", "");

    hKey->Close();
    return true;
}
