// QueueList.h: interface for the CQueueList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUEUELIST_H__5DC3A3D1_CF3B_42F9_BBBF_B5420B645B87__INCLUDED_)
#define AFX_QUEUELIST_H__5DC3A3D1_CF3B_42F9_BBBF_B5420B645B87__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCallData;

typedef CList<CCallData*, CCallData*> CQueueCallList;
typedef CMap<CString, LPCTSTR, CString, LPCTSTR> CMapQueueStrToStr;

class CQueueData
{

public:

	CQueueData(){m_lQueueDigitDetectPlayWaveId = -1; m_lQueueId = 0; m_lQueuePlayWaveId = -1;}
		
	LONG m_lQueueDigitDetectPlayWaveId;
	LONG m_lQueuePlayWaveId;

	BOOL m_bIsDigitDetect;

	ULONG m_lQueueId;

	CStringList m_objAgentList;
	CQueueCallList m_objQueueCallList;
	CMapQueueStrToStr m_objDigitDetectList;
};

typedef CMap<CString, LPCTSTR, CQueueData*, CQueueData*> CMapQueueStrToPtr;
typedef CMap<ULONG, ULONG, CQueueData*, CQueueData*> CMapQueueULongToPtr;

class CQueueList  
{

public:

	CQueueList();
	~CQueueList();

private:
	
	ULONG m_lQueueIdCount;

	CMapQueueStrToPtr* m_pQueueListTEXT;
	CMapQueueULongToPtr* m_pQueueListINT;

	ULONG ChooseQueueId();

	void UpdateCall(CCallData* pCallData, CQueueData* pQueueData);

	BOOL Add(CString sQueueName, LPCTSTR sQueuePlayWave, LPCTSTR sDigitPressPlayWave, CStringList* pAgentList, CStringList* pPressDigitList, CStringList* pUserDigitList);
	void Remove(CString sQueueName);

public:
	
	void LoadQueue();
	void UnLoadQueue();

	BOOL AddQueue(LPCTSTR sQueueName, LPCTSTR sQueuePlayWave, LPCTSTR sDigitPressPlayWave, CStringList* pAgentList, CStringList* pPressDigitList, CStringList* pUserDigitList);
	BOOL RemoveQueue(LPCTSTR sQueueName);
		
	CQueueData* FindQueue(ULONG lQueueId);
	CQueueData* FindQueue(CString sQueueName);

	void PlayDialToneToCall(CCallData* pCallData);
	void PlayQueueWaveToCall(CCallData* pCallData, ULONG lQueueWaveId, BOOL bLoopPlay);

	void DeleteAll();

	BOOL DialCallToDigitPRESS(CQueueData* pQueueData, CCallData* pQueueCallData);
	BOOL FindFreeUserId(CStringList* pListOP, CString& sFreeUserId);
	
	BOOL AddCallToQueue(CCallData* pCallData);
	
	void ProcessQueueTick();
	
	void DistributeCall(CQueueData* pQueueData);
	
	BOOL DistributeCallToQueueAgent(CQueueData* pQueueData, CCallData* pQueueCallData);
	BOOL DistributeCallToDigitPressUser(CQueueData* pQueueData, CCallData* pQueueCallData);
	
	BOOL FindUserForDigitPRESS(CQueueData* pQueueData, LPCTSTR sDigitPRESS, CString& sDigitPressUSER);
	
	void OnPressDigitDTMF(CCallData* pCallData, char sDigit);
	void OnPlayWaveDoneToCall(CCallData* pCallData);

	void RemoveQueueCall(CCallData* pCallData);
};

#endif // !defined(AFX_QUEUELIST_H__5DC3A3D1_CF3B_42F9_BBBF_B5420B645B87__INCLUDED_)
