// TelnetClient.cpp : implementation file
//

#include "stdafx.h"
#include "ServerSIP.h"
#include "TelnetServer.h"
#include "TelnetClient.h"
#include "TelnetRequest.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define AUTH_LOGIN		100
#define AUTH_PASSWORD	101
#define AUTH_DONE		102

/////////////////////////////////////////////////////////////////////////////
// CTelnetClient

CTelnetClient::CTelnetClient()
{
	m_nAuthStep = AUTH_LOGIN;
	
	m_pTelnetRequest = new CTelnetRequest;
}

CTelnetClient::~CTelnetClient()
{
	delete m_pTelnetRequest;
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CTelnetClient, CAsyncSocket)
	//{{AFX_MSG_MAP(CTelnetClient)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CTelnetClient member functions


void CTelnetClient::OnReceive(int nErrorCode) 
{
	m_pTelnetRequest->FillRecvBuffer(this);
	
	while(TRUE)
	{
		CString objRequest = m_pTelnetRequest->FindRequest(this);
		if(objRequest.IsEmpty()) break;

		if(m_nAuthStep != AUTH_DONE)
		{
			OnAuthrization(objRequest);
		}
		else
		{
			CString objCommand;
			CStringList objParamList;

			if(!m_pTelnetRequest->ParseRequest(objRequest, objCommand, &objParamList)) 
				break;

			OnRequest(objCommand, &objParamList);
		}
	}
	
	CAsyncSocket::OnReceive(nErrorCode);
}


void CTelnetClient::OnRequest(LPCTSTR sCommand, CStringList* pParamList)
{

	if(::lstrcmpi(sCommand, "BYE") == 0)
	{
		Close();
		CTelnetServer::m_pTelnetServer->OnClientDisconnect(this);

		return;
	}


	CServerSIP::m_pServerSIP->OnTelnetCommand(sCommand, pParamList, this);
}

void CTelnetClient::OnConnected() 
{
	SendText("Welcome to VaxTele!!\r\n\r\n\r\nLogin:");
}

void CTelnetClient::OnClose(int nErrorCode) 
{
	CAsyncSocket::OnClose(nErrorCode);
	CTelnetServer::m_pTelnetServer->OnClientDisconnect(this);
}

void CTelnetClient::SendCommand(LPCTSTR sCommand, CStringList* pParamList)
{
	CString sToData = sCommand;

	for(int nCount = 0; nCount < pParamList->GetCount(); nCount++)
	{
		POSITION pos   = pParamList->FindIndex(nCount);
		CString sParam = pParamList->GetAt(pos);

		sToData =  sToData + " " + sParam;
	}
	
	sToData += "\r\n";

	CAsyncSocket::Send(sToData.GetBuffer(0), sToData.GetLength());
}

void CTelnetClient::SendText(LPCTSTR sText)
{
	CAsyncSocket::Send(sText, ::lstrlen(sText));
}

void CTelnetClient::OnAuthrization(LPCTSTR sData)
{
	if(m_nAuthStep == AUTH_LOGIN)
	{
		m_nAuthStep = AUTH_PASSWORD;
		m_sLoginTelnet = sData;

		SendText("Password:");
	}
	else if(m_nAuthStep == AUTH_PASSWORD)
	{
		m_nAuthStep = AUTH_DONE;
		
		if(CTelnetServer::m_pTelnetServer->IsAuth(m_sLoginTelnet, sData))
		{
			OnSuccessToAuth();
		}
		else
		{
			OnFailToAuth();
		}

		m_sLoginTelnet = "";
	}
}

void CTelnetClient::OnSuccessToAuth()
{
	SendText("\r\nSuccess!!\r\n\r\n");
	SendText("VaxTele:>");
}

void CTelnetClient::OnFailToAuth()
{
	SendText("\r\nFail!!\r\n\r\n");

	m_nAuthStep = AUTH_LOGIN;
	SendText("Login:");
}

