using System;
using System.Collections;
using System.Text;

class cServerData
{
    private int m_nStealthSession;
    private int m_nStealthWaveId;

    private int m_nHoldSession;
    private int m_nHoldPlayWaveId;

    private int m_nDialToneWaveId;
    private int m_nDialToneSession;

    public const int QUEUE_TICK_ID = 2001;

    public cServerData()
    {
        m_nHoldSession = -1;
        m_nHoldPlayWaveId = -1;

        m_nDialToneWaveId = -1;
        m_nDialToneSession = -1;

        m_nStealthSession = -1;
        m_nStealthWaveId = -1;
    }

    public int GetDialToneSessionId()
    {
        return m_nDialToneSession;
    }

    public int GetStealthSessionId()
    {
        return m_nStealthSession;
    }

    public int GetHoldSessionId()
    {
        return m_nHoldSession;
    }

    public void LoadWavFiles()
    {
        cRegistry objReg = new cRegistry();

        string sHoldMusicWaveFile = objReg.GetHoldMusic();
        string sDialToneWaveFile = objReg.GetDialToneMusic();
        string sStealthMusicWaveFile = objReg.GetStealthListenerMusic();

        if(sHoldMusicWaveFile.Length != 0)
            cServerSIP.m_objServerSIP.LoadWaveFileToSession(sHoldMusicWaveFile, ref m_nHoldPlayWaveId, ref m_nHoldSession);
        
        if(sDialToneWaveFile.Length != 0)
            cServerSIP.m_objServerSIP.LoadWaveFileToSession(sDialToneWaveFile, ref m_nDialToneWaveId, ref m_nDialToneSession);
        
        if(sStealthMusicWaveFile.Length != 0)
            cServerSIP.m_objServerSIP.LoadWaveFileToSession(sStealthMusicWaveFile, ref m_nStealthWaveId, ref m_nStealthSession);
    }

    public void UnLoadWavFiles()
    {
        cServerSIP.m_objServerSIP.UnLoadWaveFileToSession(m_nHoldPlayWaveId, m_nHoldSession);
        cServerSIP.m_objServerSIP.UnLoadWaveFileToSession(m_nDialToneWaveId, m_nDialToneSession);
        cServerSIP.m_objServerSIP.UnLoadWaveFileToSession(m_nStealthWaveId, m_nStealthSession);
    }

    public void LoadServer()
    {
        LoadWavFiles();

        cServerSIP.m_objServerSIP.m_objLineList.LoadLines();
        cServerSIP.m_objServerSIP.m_objDialPlanList.LoadDialPlans();
        cServerSIP.m_objServerSIP.m_objQueueList.LoadQueue();

        cServerSIP.m_objServerSIP.SetVaxTeleTick(cServerSIP.QUEUE_TICK_ID, 2000); //2 seconds.
    }

    public void UnLoadServer()
    {
        UnLoadWavFiles();

        cServerSIP.m_objServerSIP.m_objLineList.UnLoadLines();
        cServerSIP.m_objServerSIP.m_objDialPlanList.UnLoadDialPlans();
        cServerSIP.m_objServerSIP.m_objQueueList.UnLoadQueue();

        cServerSIP.m_objServerSIP.KillVaxTeleTick(cServerSIP.QUEUE_TICK_ID);
    }

}

