using System;
using System.Collections;
using System.Text;


class cUserData
{
    public int m_nCallCount;
    public uint m_unUserId;

    public Boolean m_bStealthListener;
    public string m_sCodecList;
    public string m_sUserId;

    public Boolean m_bBlock;

    public cUserData()
    {
        m_nCallCount = 0;
        m_unUserId = 0;
        m_bStealthListener = false;
        m_bBlock = false;

        m_sCodecList = "";
    }
}

class cUserList
{
    uint m_unUserIdCount;

    Hashtable m_objUserListTEXT = new Hashtable(256);
    Hashtable m_objUserListINT = new Hashtable(256);

    public cUserList()
    {
        m_unUserIdCount = 0;
    }

    public uint ChooseUserId()
    {
        while (true)
        {
            m_unUserIdCount++;

            if(FindUser(m_unUserIdCount) == null)
                break;
        }

        return m_unUserIdCount;
    }

    public Boolean AddUser(string sUserId, string sUserPwd, Boolean bStealthListener, string sCodecList, Boolean bBlock)
    {
        if(cServerSIP.m_objServerSIP.AddUser(sUserId, sUserPwd) == false)
        {
            cServerSIP.m_objServerSIP.LogError("");
            return false;
        }

        Remove(sUserId);

        Add(sUserId, bStealthListener, sCodecList, bBlock);

        return true;
    }

    public void RemoveUser(string sUserId)
    {
        cServerSIP.m_objServerSIP.RemoveUser(sUserId);
        
        Remove(sUserId);
    }
        
    public cUserData FindUser(uint unUserId)
    {
        return (cUserData)m_objUserListINT[unUserId];
    }

    public cUserData FindUser(string sUserId)
    {
        return (cUserData) m_objUserListTEXT[sUserId.ToLower()];
    }

    public void DeleteAll()
    {
        m_objUserListTEXT.Clear();
        m_objUserListINT.Clear();
    }

    public int GetCallCount(string sUserId)
    {
        cUserData objUserData = FindUser(sUserId);

        if (objUserData == null)
            return -1;

        return objUserData.m_nCallCount;
    }

    private void Add(string sUserId, Boolean bStealthListener, string sCodecList, Boolean bBlock)
    {
        cUserData objUserData = new cUserData();

        objUserData.m_sUserId = sUserId;
        objUserData.m_unUserId = ChooseUserId();
        objUserData.m_bStealthListener = bStealthListener;
        objUserData.m_sCodecList = sCodecList;
        objUserData.m_bBlock = bBlock;

        m_objUserListINT.Add(objUserData.m_unUserId, objUserData);
        m_objUserListTEXT.Add(sUserId.ToLower(), objUserData);
    }

    private void Remove(string sUserId)
    {
        sUserId = sUserId.ToLower();
        cUserData objUserData = (cUserData)m_objUserListTEXT[sUserId];

        if (objUserData == null) return;

        m_objUserListINT.Remove(objUserData.m_unUserId);
        m_objUserListTEXT.Remove(sUserId);

        objUserData = null;
    }

    public int GetCount()
    {
        return m_objUserListINT.Count;
    }

}

